﻿-----------------------------------------------------------------------------
--
-- data
--   \damageDealt
--     \<damageDealerName>
--       -count, amount, maximumAmount, maximumAmountAttack, friendlyCount, friendlyAmount
--       \damageTypeDetails
--         \<damageTypeLocal>
--			 -count, amount, friendlyCount, friendlyAmount
--       \attackDetails
--         \<attackName>
--            -count, amount, maximumAmount, damageType, friendlyCount, friendlyAmount
--            \hitDetails
--			    \<attackType> -- one of Hit, Critical Hit, Tick, Miss, Dodge, Resist, etc.
--                -count, amount
--   \damageTaken
--     \<damageTakerName>
--       -count, amount, maximumAmount, maximumAmountAttack, friendlyCount, friendlyAmount
--       \damageTypeDetails
--         \<damageTypeLocal>
--			 -count, amount, friendlyCount, friendlyAmount
--       \attackDetails
--         \<attackName>
--            -count, amount, maximumAmount, damageType, friendlyCount, friendlyAmount
--            \hitDetails
--  			\<attackType>
--
-----------------------------------------------------------------------------

local L = AceLibrary("AceLocale-2.2"):new("AssessmentDamage")
L:RegisterTranslations("enUS", function() return {
	["Damage"] = true,
	["Damage Options."] = true,
	["Merge Pet Damage"] = true,
	["Merges damage dealt by pets with their owner's data."] = true,

	["Critical Hit Rate"] = true,
	["Critical Hit Rate Details"] = true,

	["Avoidance"] = true,
	["Avoidance Details"] = true,

	["Damage Dealers"] = true,
	["Damage Takers"] = true,
	["Damage Dealt"] = true,
	["Fight Damage Dealt"] = true,
	["Damage Dealt Details"] = true,
	["Damage Type Dealt Details"] = true,
	["Damage Dealt Hit Details"] = true,
	["DPS"] = true,
	["Group DPS"] = true,
	
	["Highest Hits"] = true,

	["Damage Taken"] = true,
	["Damage Type Taken Details"] = true,
	["Damage Taken Details"] = true,
	["Damage Taken Hit Details"] = true,
	["DPS"] = true,
	["Fight Damage Taken"] = true,

	["Hit"] = true,
	["Critical Hit"] = true,
	["Tick"] = true,
	["Partial Absorb"] = true,
	["Partial Block"] = true,
	["Partial Resist"] = true,
	["Glancing Hit"] = true,
	["Crushing Blow"] = true,
	["Melee"] = true,
	["Unknown"] = true,
	
	["Pet: "] = true,

	["Damage Type"] = true,
	["Colors"] = true,
	["Color options"] = true,

	["Damage Type Data"] = true,
	["Information regarding damage types taken: Fire, Frost, etc."] = true,
	["Attack Data"] = true,
	["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."] = true,
	["Hit Data"] = true,
	["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."] = true,
	["Maximum Hit Data"] = true,
	["Gather maximum hit data."] = true,
} end)

L:RegisterTranslations("zhCN", function() return {
	["Damage"] = "伤害",
	["Damage Options."] = "伤害的相关显示",
	["Merge Pet Damage"] = "合并宠物伤害",
	["Merges damage dealt by pets with their owner's data."] = "将宠物的伤害与主人的合并",

	["Critical Hit Rate"] = "暴击率",
	["Critical Hit Rate Details"] = "详细的暴击率",

	["Avoidance"] = "躲避",
	["Avoidance Details"] = "详细的躲避",

	["Damage Dealers"] = "输出伤害者",
	["Damage Takers"] = "承受伤害者",
	["Damage Dealt"] = "伤害量",
	["Fight Damage Dealt"] = "当前战斗伤害量",
	["Damage Dealt Details"] = "详细的伤害量",
	["Damage Type Dealt Details"] = "详细的伤害类型",
	["Damage Dealt Hit Details"] = "详细的击中伤害",
	["DPS"] = "DPS",
	["Group DPS"] = "队伍DPS",
	
	["Highest Hits"] = "最高伤害",

	["Damage Taken"] = "承受伤害",
	["Damage Type Taken Details"] = "详细的承受伤害类型",
	["Damage Taken Details"] = "详细的承受伤害",
	["Damage Taken Hit Details"] = "详细的被击中伤害",
	["DPS"] = "DPS",
	["Fight Damage Taken"] = "当前战斗承受伤害",

	["Hit"] = "击中",
	["Critical Hit"] = "暴击",
	["Tick"] = "DOT(每一击)",
	["Partial Absorb"] = "吸收",
	["Partial Block"] = "格挡",
	["Partial Resist"] = "抵抗",
	["Glancing Hit"] = "偏斜",
	["Crushing Blow"] = "碾压",
	["Melee"] = "近战",
	["Unknown"] = "未知",
	
	["Pet: "] = "宠物: ",


	["Damage Type"] = "伤害类型",
	["Colors"] = "颜色",
	["Color options"] = "颜色的设置",

	["Damage Type Data"] = "伤害类型数据",
	["Information regarding damage types taken: Fire, Frost, etc."] = "伤害类型信息：火，冰，等等",
	["Attack Data"] = "攻击方式数据",
	["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."] = "攻击方式信息：火球，冰剑，近战，等等",
	["Hit Data"] = "击中数据",
	["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."] = "详细的每次击中方式信息：击中，暴击，未击中，等等",
	["Maximum Hit Data"] = "最高的击中数据",
	["Gather maximum hit data."] = "获取最高的击中数据",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Damage"] = "傷害",
	["Damage Options."] = "傷害的相關顯示",
	["Merge Pet Damage"] = "合併寵物傷害",
	["Merges damage dealt by pets with their owner's data."] = "將寵物的傷害與主人的合併",

	["Critical Hit Rate"] = "暴擊率",
	["Critical Hit Rate Details"] = "詳細的暴擊率",

	["Avoidance"] = "躲避",
	["Avoidance Details"] = "詳細的躲避",

	["Damage Dealers"] = "輸出傷害者",
	["Damage Takers"] = "承受傷害者",
	["Damage Dealt"] = "傷害量",
	["Fight Damage Dealt"] = "當前戰鬥傷害量",
	["Damage Dealt Details"] = "詳細的傷害量",
	["Damage Type Dealt Details"] = "詳細的傷害類型",
	["Damage Dealt Hit Details"] = "詳細的擊中傷害",
	["DPS"] = "DPS",
	["Group DPS"] = "隊伍DPS",
	
	["Highest Hits"] = "最高傷害",

	["Damage Taken"] = "承受傷害",
	["Damage Type Taken Details"] = "詳細的承受傷害類型",
	["Damage Taken Details"] = "詳細的承受傷害",
	["Damage Taken Hit Details"] = "詳細的被擊中傷害",
	["DPS"] = "DPS",
	["Fight Damage Taken"] = "當前戰鬥承受傷害",

	["Hit"] = "擊中",
	["Critical Hit"] = "暴擊",
	["Tick"] = "DOT(每一擊)",
	["Partial Absorb"] = "吸收",
	["Partial Block"] = "格擋",
	["Partial Resist"] = "抵抗",
	["Glancing Hit"] = "偏斜",
	["Crushing Blow"] = "碾壓",
	["Melee"] = "近戰",
	["Unknown"] = "未知",
	
	["Pet: "] = "寵物: ",


	["Damage Type"] = "傷害類型",
	["Colors"] = "顏色",
	["Color options"] = "顏色的設置",

	["Damage Type Data"] = "傷害類型數據",
	["Information regarding damage types taken: Fire, Frost, etc."] = "傷害類型信息：火，冰，等等",
	["Attack Data"] = "攻擊方式數據",
	["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."] = "攻擊方式信息：火球，冰劍，近戰，等等",
	["Hit Data"] = "擊中數據",
	["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."] = "詳細的每次擊中方式信息：擊中，暴擊，未擊中，等等",
	["Maximum Hit Data"] = "最高的擊中數據",
	["Gather maximum hit data."] = "獲取最高的擊中數據",
} end)

L:RegisterTranslations("koKR", function() return {
	["Damage"] = "피해량",
	["Damage Options."] = "피해량 설정입니다.",
	["Merge Pet Damage"] = "소환수 피해량 병합",
	["Merges damage dealt by pets with their owner's data."] = "소환수가 입힌 피해량을 주인의 데이터화 합칩니다.",

	["Critical Hit Rate"] = "치명타 적중도",
	["Critical Hit Rate Details"] = "치명타 적중도 상세정보",

	["Avoidance"] = "회피",
	["Avoidance Details"] = "회피 상세정보",

	["Damage Dealers"] = "데미지 딜러",
	["Damage Takers"] = "데미지 탱커",
	["Damage Dealt"] = "입힌 피해량",
	["Fight Damage Dealt"] = "최근 입힌 피해량",
	["Damage Dealt Details"] = "입힌 피해량 상세정보",
	["Damage Type Dealt Details"] = "입힌 피해 종류 상세정보",
	["Damage Dealt Hit Details"] = "입힌 피해량 타격 상세정보",
	["DPS"] = "DPS",
	["Group DPS"] = "파티 DPS",
	
	["Highest Hits"] = "최고 타격",

	["Damage Taken"] = "받은 피해량",
	["Damage Type Taken Details"] = "받은 피해 종류 상세정보",
	["Damage Taken Details"] = "받은 피해량 상세정보",
	["Damage Taken Hit Details"] = "받은 피해량 타격 상세정보",
	["DPS"] = "DPS",
	["Fight Damage Taken"] = "최근 받은 피해량",

	["Hit"] = "타격",
	["Critical Hit"] = "치명타",
	["Tick"] = "틱당",
	["Partial Absorb"] = "부분적인 흡수",
	["Partial Block"] = "부분적인 방어",
	["Partial Resist"] = "부분적인 저항",
	["Glancing Hit"] = "빗맞음",
	["Crushing Blow"] = "강타 당함",
	["Melee"] = "근접",
	["Unknown"] = "알 수 없음",
	
	["Pet: "] = "소환수:",

	["Damage Type"] = "피해 종류",
	["Colors"] = "색상",
	["Color options"] = "색상 설정입니다.",

	["Damage Type Data"] = "피해 종류 데이터",
	["Information regarding damage types taken: Fire, Frost, etc."] = "받은 피해의 종류에 관한 정보: 화염, 냉기, 등.",
	["Attack Data"] = "공격 데이터",
	["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."] = "사용한 각 공격에 대한 정보입니다, 예. 화염구, 얼음화살, 근접, 등.",
	["Hit Data"] = "타격 데이터",
	["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."] = "사용한 각 공격에 대한 상세정보입니다, 예. 타격, 치명타, 빗맞힘, 등.",
	["Maximum Hit Data"] = "최대 타격 데이터",
	["Gather maximum hit data."] = "수집할 타격 데이터의 최대입니다.",
} end)

L:RegisterTranslations("frFR", function() return {
	["Damage"] = "Dommage",
	["Damage Options."] = "Options des Dommages.",
	["Merge Pet Damage"] = "Fusion des Dommages des Familiers",
	["Merges damage dealt by pets with their owner's data."] = "Fusionne les dommages des familiers avec les donn\195\169es de leur ma\195\174tre.",

	["Critical Hit Rate"] = "Taux de Coups Critiques",
	["Critical Hit Rate Details"] = "D\195\169tails des Taux de Coups Critiques",

	["Avoidance"] = "Esquive",
	["Avoidance Details"] = "D\195\169tails des esquives",

	["Damage Dealers"] = "Donneurs de Dommages",
	["Damage Takers"] = "Damage Takers",
	["Damage Dealt"] = "Dommages Donn\195\169s Totaux",
	["Fight Damage Dealt"] = "Dommages Donn\195\169s du Combat",
	["Damage Dealt Details"] = "D\195\169tails des Dommages Donn\195\169s",
	["Damage Type Dealt Details"] = "D\195\169tail des Types de Dommages Donn\195\169s",
	["Damage Dealt Hit Details"] = "D\195\169tails des Coups Donn\195\169es",
	["DPS"] = "DPS",
	["Group DPS"] = "DPS du Raid",
	
	["Highest Hits"] = "Coups les Plus Elev\195\169s",

	["Damage Taken"] = "Dommages re\195\167u Totaux",
	["Damage Type Taken Details"] = "D\195\169tails des Types de Dommages Re\195\167us",
	["Damage Taken Details"] = "D\195\169tails des Dommages du Combat",
	["Damage Taken Hit Details"] = "Damage Taken Hit Details",
	["DPS"] = "DPS",
	["Fight Damage Taken"] = "Dommages re\195\167u du Combat",

	["Hit"] = "Coups",
	["Critical Hit"] = "Coups Critiques",
	["Tick"] = "Tick",
	["Partial Absorb"] = "Absorb\195\169s Partiels",
	["Partial Block"] = "Bloqu\195\169s Partiels",
	["Partial Resist"] = "R\195\169sist\195\169s Partiels",
	["Glancing Hit"] = "Glancing Hit",
	["Crushing Blow"] = "Coup Ecrasant",
	["Melee"] = "M\195\169l\195\169e",
	["Unknown"] = "Inconnu",
	
	["Pet: "] = "Familier: ",

	["Damage Type"] = "Type de Dommage",
	["Colors"] = "Couleurs",
	["Color options"] = "Options des Couleurs",

	["Damage Type Data"] = "D\195\169tails des Type de Dommages",
	["Information regarding damage types taken: Fire, Frost, etc."] = "Information sur les type de dommages, ex. Feu, Givre, etc.",
	["Attack Data"] = "D\195\169tails des Attaques",
	["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."] = "Information sur les attaques effectu\195\169es, ex. Boule de Feu, Trait d'Ombre, Mutilation, etc.",
	["Hit Data"] = "D\195\169tails des Coups",
	["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."] = "Informations d\195\169taill\195\169es de chaques attaques utilis\195\169es, ex: Coups, Coups Critiques Coups Ecrasants, Rat\195\169s, etc.",
	["Maximum Hit Data"] = "Maximum Hit Data",
	["Gather maximum hit data."] = "Gather maximum hit data.",
} end)


-----------------------------------------------------------------------------

local AssessmentDamage = Assessment:NewModule("Damage", "AceEvent-2.0", "Parser-3.0")
AssessmentDamage.db = Assessment:AcquireDBNamespace("Damage")
Assessment:RegisterDefaults("Damage", "profile", {
	enable						= true,
	mergePetWithOwner			= true,
	gatherDamageTypeDataFilter	= "ALL",
	gatherAttackDataFilter		= "ALL",
	gatherHitDataFilter			= "ALL",
	gatherMaximumDataFilter		= "ALL",
	colors =
	{
		physical	= { 1, 0.75, 0.46 },
		holy		= { 1, 1, 0.5 },
		fire		= { 1, 0.3, 0 },
		nature		= { 0.5, 1, 0.2 },
		frost		= { 0.4, 0.6, 0.9 },
		shadow		= { 0.7, 0.4, 1 },
		arcane		= { 0.8, 0.8, 1 },
		unknown		= { 0, 0, 0 },
	}
})

local profile
local profileColors
local gatherDamageTypeDataMethod
local gatherAttackDataMethod
local gatherHitDataMethod
local gatherMaximumDataMethod

local emptyMethod = Assessment.EmptyMethod
local new = Assessment.NewTable
local pairs = pairs

-----------------------------------------------------------------------------

local tickAttackTypeText = L["Tick"]
local criticalHitAttackTypeText = L["Critical Hit"]
local glancingHitAttackTypeText = L["Glancing Hit"]
local crushingBlowAttackTypeText = L["Crushing Blow"]
local hitAttackTypeText = L["Hit"]
local meleeText = L["Melee"]

local partialAbsorbText = L["Partial Absorb"]
local partialBlockText = L["Partial Block"]
local partialResistText = L["Partial Resist"]

local petPrefixText = L["Pet: "]

local unknownText = L["Unknown"]

-----------------------------------------------------------------------------

Assessment.TagData.DamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end

				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				return playerDamage.amount
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.EnemyDamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end

				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				local friendlyAmount = playerDamage.friendlyAmount
				if friendlyAmount then
					return playerDamage.amount - friendlyAmount
				else
					return playerDamage.amount 
				end
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.FriendlyDamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end

				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				return playerDamage.friendlyAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageDealt =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return 0 end
				
				local playerDamage = damageDealt[data.key]
				if not playerDamage then return 0 end
				
				return playerDamage.maximumAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageDealtAttack =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return end
				
				local damageDealt = fightData.damageDealt
				if not damageDealt then return end
				
				local playerDamage = damageDealt[data.key]
				if not playerDamage then return end
				
				return playerDamage.maximumAmountAttack
			 end,
	data = "damage",
}

Assessment.TagData.DamageTaken =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return 0 end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end
				
				return playerDamage.amount
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.FriendlyDamageTaken =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return 0 end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end
				
				return playerDamage.friendlyAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageTaken =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return 0 end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return 0 end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end

				return playerDamage.maximumAmount or 0
			 end,
	data = "damage",
	guaranteeResult = true,
	numeric = true,
}

Assessment.TagData.MaximumDamageTakenAttack =
{
	method = function(data)
				local fightData = data.fightData
				if not fightData then return end
				
				local damageTaken = fightData.damageTaken
				if not damageTaken then return end
				
				local playerDamage = damageTaken[data.key]				
				if not playerDamage then return 0 end

				return playerDamage.maximumAmountAttack
			 end,
	data = "damage",
}

Assessment.TagData.MaximumAmountAttack =
{
	tableData = "value.maximumAmountAttack",
	numeric = true
}

Assessment.TagData.AbsorbAmount =
{
	tableData = "value.absorbAmount",
	numeric = true
}

Assessment.TagData.BlockAmount =
{
	tableData = "value.blockAmount",
	numeric = true
}

Assessment.TagData.ResistAmount =
{
	tableData = "value.resistAmount",
	numeric = true
}

Assessment.TagData.FriendlyAmount =
{
	tableData = "value.friendlyAmount",
	numeric = true
}

Assessment.TagData.FriendlyCount =
{
	tableData = "value.friendlyCount",
	numeric = true
}

-----------------------------------------------------------------------------

Assessment.ListType.DamageDealers =
{
	method = function(fightData)
				if not fightData or not fightData.damageDealt then return emptyMethod end
				return pairs(fightData.damageDealt)
			 end,
	data = "damage",
	description = L["Damage Dealers"],
}

Assessment.ListType.DamageTakers =
{
	method = function(fightData)
				if not fightData or not fightData.damageTaken then return emptyMethod end
				return pairs(fightData.damageTaken)
			 end,
	data = "damage",
	description = L["Damage Takers"],
}

-----------------------------------------------------------------------------

Assessment.ListType.EnumerateTable.updateData.damageDealt = "damage"
Assessment.ListType.EnumerateTable.updateData.damageTaken = "damage"

-----------------------------------------------------------------------------

Assessment.DefaultDisplaySets.DamageType =
{
	titleTag			= "[WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "[WindowParameterList],damageTypeDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	sortKeyTag			= "BarValue",
	fightIndex			= -1,
	text				= { { }, { tag= "[BarValue:Short]" } },
	description			= L["Damage Type"],
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "DamageType", count = 1 },
	favorite			= false,
	selectable			= false,
}

Assessment.DefaultDisplaySets.DamageDealtHitDetails =
{
	titleTag			= "[WindowParameter(1)]: [WindowParameter(2)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[WindowParameter(1)],attackDetails,[WindowParameter(2)],hitDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Integer]", visible = false }, count = 3 },
	description			= L["Damage Dealt Hit Details"],
	selectable			= false,
	defaultColor		= { 0.8, 0.3, 0.3 },
--	colorTypeList		= { "Custom" },
}

Assessment.DefaultDisplaySets.DamageDealtDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Dealt: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[windowParameter(1)],attackDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Integer][MaximumAmount:Prefix(\", Maximum: \")]", visible = false }, count = 3 },
	description			= L["Damage Dealt Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Dealt Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTypeDealtDetails =
{
	titleTag			= "[(fightIndex ~= 0):\"Fight \"]Damage Type Dealt: [windowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[WindowParameter(1)],damageTypeDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Damage Type Dealt Details"],
	selectable			= false,
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "DamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageDealt =
{
	titleTag			= "Damage Dealt: [TotalBarValue:short]",
	listType			= "GroupMembers", 
	barValueTag			= "EnemyDamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Damage Dealt"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.FightDamageDealt =
{
	titleTag			= "Fight Damage Dealt: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "EnemyDamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Fight Damage Dealt"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.DPS =
{
	titleTag			= "[TotalBarValue:Integer]dps ([CombatDuration:FormatDuration])",
	listType			= "GroupMembers", 
	barValueTag			= "EnemyDamageDealt / Maximum(CombatDuration, 1)", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Integer]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3  },
	description			= L["DPS"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Dealt Details"], L["Damage Dealt Details"]),
	onClickData			= "[Key]",
	favorite			= false,
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	defaultColor		= { 0.8, 0.8, 0.3 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.HighestHits =
{
	titleTag			= "Highest Hits",
	listType			= "GroupMembers", 
	barValueTag			= "MaximumDamageDealt", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { tag = "[Rank]. [Key]: [MaximumDamageDealtAttack]" }, { tag= "[BarValue:Short]" } },
	description			= L["Highest Hits"],
	defaultColor		= { 0.8, 0.3, 0.3 },
	colorTypeList		= { "Class", count = 1 },
	favorite			= false,
}

Assessment.DefaultDisplaySets.DamageTakenHitDetails =
{
	titleTag			= "[WindowParameter(1)]: [WindowParameter(2)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],attackDetails,[WindowParameter(2)],hitDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Integer]", visible = false }, count = 3 },
	description			= L["Damage Taken Hit Details"],
	selectable			= false,
	defaultColor		= { 0.8, 0.5, 0.3 },
--	colorTypeList		= { "Spell" },
}

Assessment.DefaultDisplaySets.DamageTypeTakenDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Type Taken: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],damageTypeDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Damage Type Taken Details"],
	selectable			= false,
	defaultColor		= { 0.8, 0.5, 0.3 },
	colorTypeList		= { "DamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTakenDetails =
{
	titleTag			= "[(FightIndex ~= 0):\"Fight \"]Damage Taken: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[WindowParameter(1)],attackDetails",
	barValueTag			= "Amount",
	filterTag			= "1",
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([Count])" }, { tag = "[BarValue:Short]" }, { tag = "Average: [(BarValue/Count):Integer][MaximumAmount:Prefix(\", Maximum: \")]", visible = false }, count = 3 },
	description			= L["Damage Taken Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Taken Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	defaultColor		= { 0.8, 0.5, 0.3 },
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.DamageTaken =
{
	titleTag			= "Damage Taken: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageTaken", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 0,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Damage Taken"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Taken Details"], L["Damage Taken Details"]),
	onClickData			= "[Key]",
	segmentEnable		= true,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageTaken,[Key]",
	defaultColor		= { 0.8, 0.5, 0.3 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.FightDamageTaken =
{
	titleTag			= "Fight Damage Taken: [TotalBarValue:Short]",
	listType			= "GroupMembers", 
	barValueTag			= "DamageTaken", 
	filterTag			= "BarValue ~= 0",
	fightIndex			= 1,
	text				= { { }, { tag= "[BarValue:Short]" }, { tag = "[(BarValue/TotalBarValue):Percent]", visible = false }, count = 3 },
	description			= L["Fight Damage Taken"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= string.format("[Select(IsControlKeyDown, %q, %q)]", L["Damage Type Taken Details"], L["Damage Taken Details"]),
	onClickData			= "[Key]",
	segmentEnable		= true,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageTaken,[Key]",
	defaultColor		= { 0.8, 0.5, 0.3 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.CriticalHitRateDetails =
{
	titleTag			= "Critical Hit Rate: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageDealt,[windowParameter(1)],attackDetails",
	barValueTag			= "GetValueField(\"hitDetails\", \"Critical Hit\", \"count\") / (GetValueField(\"hitDetails\", \"Critical Hit\", \"count\")+GetValueField(\"hitDetails\", \"Hit\", \"count\"))",
	filterTag			= "BarValue == BarValue", -- This is a NaN check
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([GetValueField(\"hitDetails\", \"Critical Hit\", \"count\")||0]/[(GetValueField(\"hitDetails\", \"Critical Hit\", \"count\")+GetValueField(\"hitDetails\", \"Hit\", \"count\"))])" }, 
							{ tag = "[BarValue:Percent]" },
							count = 2,
						  },
	description			= L["Critical Hit Rate Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Dealt Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	defaultColor		= { 0.8, 0.3, 0.8 },
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.CriticalHitRate =
{
	titleTag			= L["Critical Hit Rate"],
	listType			= "GroupMembers", 
	barValueTag			= "SumField(\"damageDealt\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Critical Hit\", \"count\"):SetVariable(\"CriticalHitCount\") / (GetVariable(\"CriticalHitCount\")+SumField(\"damageDealt\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Hit\", \"count\")):SetVariable(\"TotalHitCount\")", 
	filterTag			= "BarValue == BarValue", -- This is a NaN check
	fightIndex			= 0,
	text				= { { tag = "[Rank]. [Key] ([GetVariable(\"CriticalHitCount\")]/[GetVariable(\"TotalHitCount\")])" }, 
							{ tag= "[BarValue:Percent]" }, 
							count = 2,
						  },
	description			= L["Critical Hit Rate"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Critical Hit Rate Details"],
	onClickData			= "[Key]",
	segmentEnable		= false,
	segmentDisplaySet	= L["Damage Type"],
	segmentData			= "damageDealt,[Key]",
	defaultColor		= { 0.8, 0.3, 0.8 },
	colorTypeList		= { "Class", count = 1 },
}

Assessment.DefaultDisplaySets.AvoidanceDetails =
{
	titleTag			= "Avoidance: [WindowParameter(1)]",
	listType			= "EnumerateTable", 
	listDataTag			= "damageTaken,[windowParameter(1)],attackDetails",
	barValueTag			= "(GetValueField(\"hitDetails\", \"Block\", \"count\")+GetValueField(\"hitDetails\", \"Dodge\", \"count\")+GetValueField(\"hitDetails\", \"Miss\", \"count\")+GetValueField(\"hitDetails\", \"Parry\", \"count\")+GetValueField(\"hitDetails\", \"Resist\", \"count\")):SetVariable(\"Avoided\") / Count",
	filterTag			= "BarValue == BarValue", -- This is a NaN check
	fightIndex			= -1,
	text				= { { tag = "[Rank]. [Key] ([GetVariable(\"Avoided\")||0]/[Count])" }, 
							{ tag = "[BarValue:Percent]" },
							count = 2,
						  },
	description			= L["Avoidance Details"],
	selectable			= false,
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Damage Taken Hit Details"],
	onClickData			= "[WindowParameter(1)],[Key]",
	defaultColor		= { 0.3, 0.8, 0.5 },
	colorTypeList		= { "SpellDamageType", count = 1 },
}

Assessment.DefaultDisplaySets.Avoidance =
{
	titleTag			= L["Avoidance"],
	listType			= "GroupMembers", 
	barValueTag			= "(SumField(\"damageTaken\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Block\", \"count\")+SumField(\"damageTaken\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Dodge\", \"count\")+SumField(\"damageTaken\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Miss\", \"count\")+SumField(\"damageTaken\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Parry\", \"count\")+SumField(\"damageTaken\", Key, \"attackDetails\", \"*\", \"hitDetails\", \"Resist\", \"count\")):SetVariable(\"Avoided\") / GetField(\"damageTaken\", Key, \"count\")",
	filterTag			= "BarValue == BarValue", -- This is a NaN check
	fightIndex			= 1,
	text				= { { tag = "[Rank]. [Key] ([GetVariable(\"Avoided\")]/[GetField(\"damageTaken\", Key, \"count\")])" }, 
							{ tag= "[BarValue:Percent]" }, 
							count = 2,
						  },
	description			= L["Avoidance"],
	onClickType			= "SHOW_DISPLAY_SET",
	onClickDisplaySet	= L["Avoidance Details"],
	onClickData			= "[Key]",
	defaultColor		= { 0.3, 0.8, 0.5 },
	colorTypeList		= { "Class", count = 1 },
}

-----------------------------------------------------------------------------

local function getColor(passValue)
	return unpack(profileColors[passValue])
end

local function setColor(passValue,r, g, b)
	profileColors[passValue] = { r, g, b }
	Assessment:RedrawAll()
end

Assessment.Options.args.data.args.damage =
{
	type = "group",
	name = L["Damage"],
	desc = L["Damage Options."],
	args =
	{
		gatherDamageType =
		{
			type = "text",
			name = L["Damage Type Data"],
			desc = L["Information regarding damage types taken: Fire, Frost, etc."],
			get = function() return profile.gatherDamageTypeDataFilter end,
			set = function(v) profile.gatherDamageTypeDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = Assessment.GatherFilterValidate,
		},
		gatherAttackData =
		{
			type = "text",
			name = L["Attack Data"],
			desc = L["Information about each attack used, eg. Fireball, Frostbolt, Melee, etc."],
			get = function() return profile.gatherAttackDataFilter end,
			set = function(v) profile.gatherAttackDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = Assessment.GatherFilterValidate,
		},
		gatherHitData =
		{
			type = "text",
			name = L["Hit Data"],
			desc = L["Detailed information about each attack used, eg. Hit, Critical Hit, Miss, etc."],
			get = function() return profile.gatherHitDataFilter end,
			set = function(v) profile.gatherHitDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = Assessment.GatherFilterValidate,
		},
		gatherMaximumHitData =
		{
			type = "text",
			name = L["Maximum Hit Data"],
			desc = L["Gather maximum hit data."],
			get = function() return profile.gatherMaximumDataFilter end,
			set = function(v) profile.gatherMaximumDataFilter = v AssessmentDamage:OnInitialize() end,
			validate = Assessment.GatherFilterValidate,
		},
		mergePetWithOwner =
		{
			type = "toggle",
			name = L["Merge Pet Damage"],
			desc = L["Merges damage dealt by pets with their owner's data."],
			get = function() return profile.mergePetWithOwner end,
			set = function(v) profile.mergePetWithOwner = v end,
		},
		color =
		{
			type = "group",
			name = L["Colors"],
			desc = L["Color options"],
			args =
			{
				-- Filled in below
			},
		},
	}
}

-----------------------------------------------------------------------------

local localDamageTypeToColorName = 
{ 
	[SPELL_SCHOOL0_CAP] = "physical",
	[SPELL_SCHOOL1_CAP] = "holy",
	[SPELL_SCHOOL2_CAP] = "fire",
	[SPELL_SCHOOL3_CAP] = "nature",
	[SPELL_SCHOOL4_CAP] = "frost",
	[SPELL_SCHOOL5_CAP] = "shadow",
	[SPELL_SCHOOL6_CAP] = "arcane",
	[UNKNOWN]			= "unknown"
}

for k,v in pairs(localDamageTypeToColorName) do
	Assessment.Options.args.data.args.damage.args.color.args[v] =
	{
		type = "color",
		name = k,
		desc = k,
		get = getColor,
		set = setColor,
		passValue = v
	}
end

-----------------------------------------------------------------------------

Assessment.ColorType.DamageType = 
{
	method = function(fightData, data)
				local colorName = localDamageTypeToColorName[data.key]
				if not colorName then return nil end
				return profileColors[colorName]
			 end,
	description = L["Damage Type"]
}

Assessment.ColorType.SpellDamageType = 
{
	method = function(fightData, data)
				local damageType = data.value.damageType
				if not damageType then return end
				
				return profileColors[damageType]
			 end,
	description = L["Damage Type"]
}

-----------------------------------------------------------------------------

Assessment.DefaultTags.DamageDealt =
{
	tag			= "[DamageDealt:Short]",
	fightIndex	= 0,
	description	= L["Damage Dealt"],
}

Assessment.DefaultTags.FightDamageDealt =
{
	tag			= "[DamageDealt:Short]",
	fightIndex	= 1,
	description	= L["Fight Damage Dealt"],
}

Assessment.DefaultTags.DamageTaken =
{
	tag			= "[DamageTaken:Short]",
	fightIndex	= 0,
	description	= L["Damage Taken"],
}

Assessment.DefaultTags.FightDamageTaken =
{
	tag			= "[DamageTaken:Short]",
	fightIndex	= 1,
	description	= L["Fight Damage Taken"],
}

Assessment.DefaultTags.DPS =
{
	tag			= "[(DamageDealt / Maximum(CombatDuration, 1)):Integer]",
	fightIndex	= 1,
	description	= L["DPS"],
}

Assessment.DefaultTags.GroupDPS =
{
	tag			= "[(SumGroupField(\"damageDealt\", \"*\", \"amount\") / Maximum(CombatDuration, 1)):Integer]",
	fightIndex	= 1,
	description	= L["Group DPS"],
}

-----------------------------------------------------------------------------

function AssessmentDamage:OnInitialize()
	profile						= self.db.profile
	profileColors				= profile.colors
	gatherDamageTypeDataMethod	= Assessment.GatherFilterList[profile.gatherDamageTypeDataFilter].method
	gatherAttackDataMethod		= Assessment.GatherFilterList[profile.gatherAttackDataFilter].method
	gatherHitDataMethod			= Assessment.GatherFilterList[profile.gatherHitDataFilter].method
	gatherMaximumDataMethod		= Assessment.GatherFilterList[profile.gatherMaximumDataFilter].method
end

function AssessmentDamage:OnEnable()
	self:RegisterParserEvent({ eventType = "Damage" }, "OnParserDamageEvent")
	self:RegisterParserEvent({ eventType = "Environmental" }, "OnParserEnvironmentalEvent")
	self:RegisterParserEvent({ eventType = "Miss" }, "OnParserMissEvent")
end

function AssessmentDamage:OnDisable()
end

-----------------------------------------------------------------------------

local petToOwnerTable = { pet = "player" }
for i=1,4 do petToOwnerTable["partypet"..i] = "party"..i end
for i=1,40 do petToOwnerTable["raidpet"..i] = "raid"..i end

-----------------------------------------------------------------------------

-- Since UpdateDamageData and UpdateMissData are called a lot, they have been
-- expanded to save the overhead of lua function calls/lookups.

local function UpdateDamageData(dataTable, member, eventData, attackType, abilityName)
	local amount = eventData.amount

	local data = dataTable[member]
	if data then
		data.count = data.count + 1
		data.amount = data.amount + amount
	else
		data = new()
		data.count  = 1
		data.amount = amount
		data.attackDetails = new()
		data.damageTypeDetails = new()
		dataTable[member] = data
	end
	
	local gatherMaximum = gatherMaximumDataMethod(member)
	if gatherMaximum then
		local maximumAmount = data.maximumAmount
		if not maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		elseif amount > maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		end
	end

	local damageTypeLocal = eventData.damageTypeLocal
	if gatherDamageTypeDataMethod(member) then
		local damageTypeDetailsParent = data.damageTypeDetails
		local damageTypeDetails = damageTypeDetailsParent[damageTypeLocal]
		if damageTypeDetails then
			damageTypeDetails.count = damageTypeDetails.count + 1
			damageTypeDetails.amount = damageTypeDetails.amount + amount
		else
			damageTypeDetails = new()
			damageTypeDetails.count = 1
			damageTypeDetails.amount = amount
			damageTypeDetailsParent[damageTypeLocal] = damageTypeDetails
		end
	end

	if gatherAttackDataMethod(member) then	
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if attackDetails then
			attackDetails.count = attackDetails.count + 1
			attackDetails.amount = attackDetails.amount + amount
		else
			attackDetails = new()
			attackDetails.count	 = 1
			attackDetails.amount = amount
			attackDetails.hitDetails = new()
			attackDetailsParent[abilityName] = attackDetails
		end
		attackDetails.damageType = localDamageTypeToColorName[damageTypeLocal]

		if gatherMaximum then
			local maximumAmount = attackDetails.maximumAmount
			if not maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			elseif amount > maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			end
		end
		
		if gatherHitDataMethod(member) then
			local hitDetails = attackDetails.hitDetails
			local attackTypeDetails = hitDetails[attackType]
			if attackTypeDetails then
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.amount = attackTypeDetails.amount + amount
			else 
				attackTypeDetails = new()
				attackTypeDetails.count = 1
				attackTypeDetails.amount = amount
				hitDetails[attackType] = attackTypeDetails
			end
			
			local absorbAmount = eventData.absorbAmount
			if absorbAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialAbsorbText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + absorbAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count  = 1
					attackTypeDetails.amount = absorbAmount
					hitDetails[partialAbsorbText] = attackTypeDetails
				end
			end

			local blockAmount = eventData.blockAmount
			if blockAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialBlockText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + blockAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count = 1
					attackTypeDetails.amount = blockAmount
					hitDetails[partialBlockText] = attackTypeDetails
				end
			end

			local resistAmount = eventData.resistAmount
			if resistAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialResistText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + resistAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count = 1
					attackTypeDetails.amount = resistAmount
					hitDetails[partialResistText] = attackTypeDetails
				end
			end
		end
	end
end

local function UpdateFriendlyDamageData(dataTable, member, eventData, attackType, abilityName)
	local amount = eventData.amount

	local data = dataTable[member]
	if data then
		data.count = data.count + 1
		data.amount = data.amount + amount
		data.friendlyCount = (data.friendlyCount or 0) + 1
		data.friendlyAmount = (data.friendlyAmount or 0) + amount
	else
		data = new()
		data.count = 1
		data.amount = amount
		data.friendlyCount = 1
		data.friendlyAmount = amount
		data.attackDetails = new()
		data.damageTypeDetails = new()
		dataTable[member] = data
	end
	
	local gatherMaximum = gatherMaximumDataMethod(member)
	if gatherMaximum then
		local maximumAmount = data.maximumAmount
		if not maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		elseif amount > maximumAmount then
			data.maximumAmount = amount
			data.maximumAmountAttack = abilityName
		end
	end

	local damageTypeLocal = eventData.damageTypeLocal
	if gatherDamageTypeDataMethod(member) then
		local damageTypeDetailsParent = data.damageTypeDetails
		local damageTypeDetails = damageTypeDetailsParent[damageTypeLocal]
		if damageTypeDetails then
			damageTypeDetails.count = damageTypeDetails.count + 1
			damageTypeDetails.amount = damageTypeDetails.amount + amount
			damageTypeDetails.friendlyCount = (damageTypeDetails.friendlyCount or 0) + 1
			damageTypeDetails.friendlyAmount = (damageTypeDetails.friendlyAmount or 0) + amount
		else
			damageTypeDetails = new()
			damageTypeDetails.count = 1
			damageTypeDetails.amount = amount
			damageTypeDetails.friendlyCount = 1
			damageTypeDetails.friendlyAmount = amount
			damageTypeDetailsParent[damageTypeLocal] = damageTypeDetails
		end
	end

	if gatherAttackDataMethod(member) then	
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if attackDetails then
			attackDetails.count = attackDetails.count + 1
			attackDetails.amount = attackDetails.amount + amount
			attackDetails.friendlyCount = (attackDetails.friendlyCount or 0) + 1
			attackDetails.friendlyAmount = (attackDetails.friendlyAmount or 0) + amount
		else
			attackDetails = new()
			attackDetails.count	 = 1
			attackDetails.amount = amount
			attackDetails.friendlyCount = 1
			attackDetails.friendlyAmount = amount
			attackDetails.hitDetails = new()
			attackDetailsParent[abilityName] = attackDetails
		end
		attackDetails.damageType = localDamageTypeToColorName[damageTypeLocal]

		if gatherMaximum then
			local maximumAmount = attackDetails.maximumAmount
			if not maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			elseif amount > maximumAmount then
				attackDetails.maximumAmount = amount
				attackDetails.maximumAmountAttack = abilityName
			end
		end
		
		if gatherHitDataMethod(member) then
			local hitDetails = attackDetails.hitDetails
			local attackTypeDetails = hitDetails[attackType]
			if attackTypeDetails then
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.amount = attackTypeDetails.amount + amount
				attackTypeDetails.friendlyCount = (attackTypeDetails.friendlyCount or 0) + 1
				attackTypeDetails.friendlyAmount = (attackTypeDetails.friendlyAmount or 0) + amount
			else 
				attackTypeDetails = new()
				attackTypeDetails.count = 1
				attackTypeDetails.amount = amount
				attackTypeDetails.friendlyCount = 1
				attackTypeDetails.friendlyAmount = amount
				hitDetails[attackType] = attackTypeDetails
			end
			
			local absorbAmount = eventData.absorbAmount
			if absorbAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialAbsorbText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + absorbAmount
					attackTypeDetails.friendlyCount = (attackTypeDetails.friendlyCount or 0) + 1
					attackTypeDetails.friendlyAmount = (attackTypeDetails.friendlyAmount or 0) + absorbAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count  = 1
					attackTypeDetails.amount = absorbAmount
					attackTypeDetails.friendlyCount = 1
					attackTypeDetails.friendlyAmount = absorbAmount
					hitDetails[partialAbsorbText] = attackTypeDetails
				end
			end

			local blockAmount = eventData.blockAmount
			if blockAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialBlockText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + blockAmount
					attackTypeDetails.friendlyCount = (attackTypeDetails.friendlyCount or 0) + 1
					attackTypeDetails.friendlyAmount = (attackTypeDetails.friendlyAmount or 0) + blockAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count = 1
					attackTypeDetails.amount = blockAmount
					attackTypeDetails.friendlyCount = 1
					attackTypeDetails.friendlyAmount = blockAmount
					hitDetails[partialBlockText] = attackTypeDetails
				end
			end

			local resistAmount = eventData.resistAmount 
			if resistAmount ~= 0 then
				local attackTypeDetails = hitDetails[partialResistText]
				if attackTypeDetails then
					attackTypeDetails.count = attackTypeDetails.count + 1
					attackTypeDetails.amount = attackTypeDetails.amount + resistAmount
					attackTypeDetails.friendlyCount = (attackTypeDetails.friendlyCount or 0) + 1
					attackTypeDetails.friendlyAmount = (attackTypeDetails.friendlyAmount or 0) + resistAmount
				else
					attackTypeDetails = new()
					attackTypeDetails.count = 1
					attackTypeDetails.amount = resistAmount
					attackTypeDetails.friendlyCount = 1
					attackTypeDetails.friendlyAmount = resistAmount
					hitDetails[partialResistText] = attackTypeDetails
				end
			end
		end
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:OnParserDamageEvent(eventData)
	local sourceName = eventData.sourceName
	local abilityName = eventData.abilityName or meleeText
	local attackType = eventData.isDoT and tickAttackTypeText or 
						eventData.isCrit and criticalHitAttackTypeText or 
						eventData.isGlancing and glancingHitAttackTypeText or 
						eventData.isCrushing and crushingBlowAttackTypeText or
						hitAttackTypeText

	if profile.mergePetWithOwner then
		local sourceOwnerID = petToOwnerTable[eventData.sourceID]
		if sourceOwnerID then
			abilityName = petPrefixText..abilityName
			sourceName = UnitName(sourceOwnerID)
		end
	end
	
	local updateMethod = eventData.sourceID and eventData.recipientID and UpdateFriendlyDamageData or UpdateDamageData
	
	local time = GetTime()
	for data in self:IterateUpdateDataTables() do
		data.dataUpdateTimes.damage = time
		
		local damageDealt = data.damageDealt
		if not damageDealt then
			damageDealt = new()
			data.damageDealt = damageDealt
		end

		local damageTaken = data.damageTaken
		if not damageTaken then
			damageTaken = new()
			data.damageTaken = damageTaken
		end

		updateMethod(damageDealt, sourceName, eventData, attackType, abilityName)
		updateMethod(damageTaken, eventData.recipientName, eventData, attackType, abilityName)
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:OnParserEnvironmentalEvent(eventData)
	local time = GetTime()
	for data in self:IterateUpdateDataTables() do
		data.dataUpdateTimes.damage = time
		
		local damageTaken = data.damageTaken
		if not damageTaken then
			damageTaken = new()
			data.damageTaken = damageTaken
		end

		UpdateDamageData(damageTaken, eventData.recipientName, eventData, eventData.hazardTypeLocal, eventData.hazardTypeLocal)
	end
end

-----------------------------------------------------------------------------

local function UpdateMissData(dataTable, member, eventData, abilityName)
	local data = dataTable[member]
	if data then
		data.count = data.count + 1
	else
		data = new()
		data.count = 1
		data.amount = 0
		data.attackDetails = new()
		data.damageTypeDetails = new()
		dataTable[member] = data
	end
	
	if gatherAttackDataMethod(member) then
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if attackDetails then
			attackDetails.count = attackDetails.count + 1
		else
			attackDetails = new()
			attackDetails.count = 1
			attackDetails.amount = 0
			attackDetails.hitDetails = new()
			attackDetailsParent[abilityName] = attackDetails
		end
		
		if gatherHitDataMethod(member) then		
			local hitDetails = attackDetails.hitDetails
			local missTypeLocal = eventData.missTypeLocal
			local attackTypeDetails = hitDetails[missTypeLocal]
			if attackTypeDetails then
				attackTypeDetails.count = attackTypeDetails.count + 1
			else
				attackTypeDetails = new()
				attackTypeDetails.count = 1
				attackTypeDetails.amount = 0
				hitDetails[missTypeLocal] = attackTypeDetails
			end
		end
	end
end

local function UpdateFriendlyMissData(dataTable, member, eventData, abilityName)
	local data = dataTable[member]
	if data then
		data.count = data.count + 1
		data.friendlyCount = (data.friendlyCount or 0) + 1
	else
		data = new()
		data.count = 1
		data.amount = 0
		data.friendlyCount = 1
		data.attackDetails = new()
		data.damageTypeDetails = new()
		dataTable[member] = data
	end
	
	if gatherAttackDataMethod(member) then
		local attackDetailsParent = data.attackDetails
		local attackDetails = attackDetailsParent[abilityName]
		if attackDetails then
			attackDetails.count = attackDetails.count + 1
			attackDetails.friendlyCount = (attackDetails.friendlyCount or 0) + 1
		else
			attackDetails = new()
			attackDetails.count = 1
			attackDetails.amount = 0
			attackDetails.friendlyCount = 1
			attackDetails.hitDetails = new()
			attackDetailsParent[abilityName] = attackDetails
		end
		
		if gatherHitDataMethod(member) then		
			local hitDetails = attackDetails.hitDetails
			local missTypeLocal = eventData.missTypeLocal
			local attackTypeDetails = hitDetails[missTypeLocal]
			if attackTypeDetails then
				attackTypeDetails.count = attackTypeDetails.count + 1
				attackTypeDetails.friendlyCount = (attackTypeDetails.friendlyCount or 0) + 1
			else
				attackTypeDetails = new()
				attackTypeDetails.count = 1
				attackTypeDetails.amount = 0
				attackTypeDetails.friendlyCount = 1
				hitDetails[missTypeLocal] = attackTypeDetails
			end
		end
	end
end

-----------------------------------------------------------------------------

function AssessmentDamage:OnParserMissEvent(eventData)
	local sourceName = eventData.sourceName or unknownText
	local abilityName = eventData.abilityName or meleeText

	if profile.mergePetWithOwner then
		local sourceOwnerID = petToOwnerTable[eventData.sourceID]
		if sourceOwnerID then
			abilityName = petPrefixText..abilityName
			sourceName = UnitName(sourceOwnerID)
		end
	end

	local updateMethod = eventData.sourceID and eventData.recipientID and UpdateFriendlyMissData or UpdateMissData
	
	local time = GetTime()
	for data in self:IterateUpdateDataTables() do
		data.dataUpdateTimes.damage = time
		
		local damageDealt = data.damageDealt
		if not damageDealt then
			damageDealt = new()
			data.damageDealt = damageDealt
		end

		local damageTaken = data.damageTaken
		if not damageTaken then
			damageTaken = new()
			data.damageTaken = damageTaken
		end

		updateMethod(damageDealt, sourceName, eventData, abilityName)
		updateMethod(damageTaken, eventData.recipientName, eventData, abilityName)
	end
end

-----------------------------------------------------------------------------
